#ifndef MYX_MATH_FLOAT_CMP_TYPES_HPP_
#define MYX_MATH_FLOAT_CMP_TYPES_HPP_

#pragma once

#include <cstdint>

/**
 * @brief Объединение для получения знака аргумента типа float.
 */
union FloatCmp
{
	int32_t i;
	float   f;

	/**
	 * @brief Инициализация.
	 */
	explicit FloatCmp( float num = 0.0F ) : f( num )
	{
	}

	/**
	 * @brief Функция, возращающая true, если значение отрицательное
	 */
	bool negative() const
	{
		return( i < 0 );
	}
};

/**
 * @brief Объединение для получения знака аргумента типа double.
 */
union DoubleCmp
{
	int64_t i;
	double  d;

	/**
	 * @brief Инициализация.
	 */
	explicit DoubleCmp( double num = 0.0L ) : d( num )
	{
	}

	/**
	 * @brief Функция, возращающая true, если значение отрицательное
	 */
	bool negative() const
	{
		return( i < 0 );
	}
};

#endif // MYX_MATH_FLOAT_CMP_TYPES_HPP_
